Index: soft/giet_vm/boot/boot_init.c
===================================================================
--- soft/giet_vm/boot/boot_init.c	(revision 236)
+++ soft/giet_vm/boot/boot_init.c	(revision 238)
@@ -1660,11 +1730,14 @@
                     boot_exit();
                 }
-
             }
-            // ctx_dma : DMA global index provided by a cluster allocator  
+            // ctx_dma : the local channel index is defined by the cluster allocator  
+            //           but the ctx_dma value is a global index
             unsigned int ctx_dma = 0xFFFFFFFF;
-            if (task[task_id].use_fbdma || task[task_id].use_nic) {
+            if ( task[task_id].use_dma ) 
+            {
                 unsigned int cluster_id = task[task_id].clusterid;
-                if (alloc_dma_channel[cluster_id] >= NB_DMAS_MAX) {
+
+                if (alloc_dma_channel[cluster_id] >= NB_DMA_CHANNELS) 
+                {
                     boot_puts("\n[BOOT ERROR] local DMA index too large for task ");
                     boot_puts(task[task_id].name);
@@ -1674,10 +1747,11 @@
                     boot_exit();
                 }
-                ctx_dma = cluster_id * NB_DMAS_MAX + alloc_dma_channel[cluster_id];
+                ctx_dma = cluster_id * NB_DMA_CHANNELS + alloc_dma_channel[cluster_id];
                 alloc_dma_channel[cluster_id]++;
             }
             // ctx_epc : Get the virtual address of the start function
-            mapping_vobj_t * pvobj = &vobj[vspace[vspace_id].vobj_offset + vspace[vspace_id].start_offset];
-            unsigned int * start_vector_vbase = (unsigned int *) pvobj->vaddr;
+            mapping_vobj_t* pvobj = &vobj[vspace[vspace_id].vobj_offset + 
+                                     vspace[vspace_id].start_offset];
+            unsigned int* start_vector_vbase = (unsigned int *) pvobj->vaddr;
             unsigned int ctx_epc = start_vector_vbase[task[task_id].startid];
 
@@ -1686,12 +1760,9 @@
             unsigned int ctx_sp = vobj[vobj_id].vaddr + vobj[vobj_id].length;
 
-            // In the code below, we access the scheduler with specific access 
-            // functions, because we only have the physical address of the scheduler, 
-            // and these functions must temporary desactivate the DTLB...
-
-            // get local task index in scheduler[gpid]
-            unsigned int ltid = boot_scheduler_get_tasks(gpid);
-
-            if (ltid >= IDLE_TASK_INDEX) {
+            // get local task index in scheduler
+            unsigned int ltid = psched->tasks;
+
+            if (ltid >= IDLE_TASK_INDEX) 
+            {
                 boot_puts("\n[BOOT ERROR] : ");
                 boot_putd(ltid);
@@ -1701,58 +1772,66 @@
                 boot_exit();
             }
-            // update the "tasks" field in scheduler[gpid]
-            boot_scheduler_set_tasks(gpid, ltid + 1);
-
-            // update the "current" field in scheduler[gpid]
-            boot_scheduler_set_current(gpid, 0);
-
-            // initializes the task context in scheduler[gpid]
-            boot_scheduler_set_context(gpid, ltid, CTX_SR_ID, ctx_sr);
-            boot_scheduler_set_context(gpid, ltid, CTX_SP_ID, ctx_sp);
-            boot_scheduler_set_context(gpid, ltid, CTX_RA_ID, ctx_ra);
-            boot_scheduler_set_context(gpid, ltid, CTX_EPC_ID, ctx_epc);
-            boot_scheduler_set_context(gpid, ltid, CTX_PTPR_ID, ctx_ptpr);
-            boot_scheduler_set_context(gpid, ltid, CTX_TTY_ID, ctx_tty);
-            boot_scheduler_set_context(gpid, ltid, CTX_DMA_ID, ctx_dma);
-            boot_scheduler_set_context(gpid, ltid, CTX_NIC_ID, ctx_nic);
-            boot_scheduler_set_context(gpid, ltid, CTX_TIMER_ID, ctx_timer);
-            boot_scheduler_set_context(gpid, ltid, CTX_PTAB_ID, ctx_ptab);
-            boot_scheduler_set_context(gpid, ltid, CTX_LTID_ID, ltid);
-            boot_scheduler_set_context(gpid, ltid, CTX_VSID_ID, vspace_id);
-            boot_scheduler_set_context(gpid, ltid, CTX_GTID_ID, task_id);
-            boot_scheduler_set_context(gpid, ltid, CTX_RUN_ID, 1);
+            // update the "tasks" field in scheduler
+            psched->tasks = ltid + 1;
+
+            // update the "current" field in scheduler
+            psched->current = 0;
+
+            // initializes the task context in scheduler
+            psched->context[ltid][CTX_SR_ID]    = ctx_sr;
+            psched->context[ltid][CTX_SP_ID]    = ctx_sp;
+            psched->context[ltid][CTX_RA_ID]    = ctx_ra;
+            psched->context[ltid][CTX_EPC_ID]   = ctx_epc;
+            psched->context[ltid][CTX_PTPR_ID]  = ctx_ptpr;
+            psched->context[ltid][CTX_TTY_ID]   = ctx_tty;
+            psched->context[ltid][CTX_CMA_ID]   = ctx_cma;
+            psched->context[ltid][CTX_IOC_ID]   = ctx_ioc;
+            psched->context[ltid][CTX_NIC_ID]   = ctx_nic;
+            psched->context[ltid][CTX_TIM_ID]   = ctx_tim;
+            psched->context[ltid][CTX_DMA_ID]   = ctx_dma;
+            psched->context[ltid][CTX_PTAB_ID]  = ctx_ptab;
+            psched->context[ltid][CTX_LTID_ID]  = ltid;
+            psched->context[ltid][CTX_GTID_ID]  = task_id;
+            psched->context[ltid][CTX_VSID_ID]  = vspace_id;
+            psched->context[ltid][CTX_RUN_ID]   = 1;
 
 #if BOOT_DEBUG_SCHED
-            boot_puts("\nTask ");
-            boot_puts(task[task_id].name);
-            boot_puts(" (");
-            boot_putd(task_id);
-            boot_puts(") allocated to processor ");
-            boot_putd(gpid);
-            boot_puts("\n  - ctx[LTID]   = ");
-            boot_putd(ltid);
-            boot_puts("\n  - ctx[SR]     = ");
-            boot_putx(ctx_sr);
-            boot_puts("\n  - ctx[SR]     = ");
-            boot_putx(ctx_sp);
-            boot_puts("\n  - ctx[RA]     = ");
-            boot_putx(ctx_ra);
-            boot_puts("\n  - ctx[EPC]    = ");
-            boot_putx(ctx_epc);
-            boot_puts("\n  - ctx[PTPR]   = ");
-            boot_putx(ctx_ptpr);
-            boot_puts("\n  - ctx[TTY]    = ");
-            boot_putd(ctx_tty);
-            boot_puts("\n  - ctx[NIC]    = ");
-            boot_putd(ctx_nic);
-            boot_puts("\n  - ctx[TIMER]  = ");
-            boot_putd(ctx_timer);
-            boot_puts("\n  - ctx[DMA]    = ");
-            boot_putd(ctx_dma);
-            boot_puts("\n  - ctx[PTAB]   = ");
-            boot_putx(ctx_ptab);
-            boot_puts("\n  - ctx[VSID]   = ");
-            boot_putd(vspace_id);
-            boot_puts("\n");
+boot_puts("\nTask ");
+boot_puts(task[task_id].name);
+boot_puts(" (");
+boot_putd(task_id);
+boot_puts(") allocated to processor ");
+boot_putd(gpid);
+boot_puts("\n  - ctx[LTID]   = ");
+boot_putd(ltid);
+boot_puts("\n  - ctx[SR]     = ");
+boot_putx(ctx_sr);
+boot_puts("\n  - ctx[SR]     = ");
+boot_putx(ctx_sp);
+boot_puts("\n  - ctx[RA]     = ");
+boot_putx(ctx_ra);
+boot_puts("\n  - ctx[EPC]    = ");
+boot_putx(ctx_epc);
+boot_puts("\n  - ctx[PTPR]   = ");
+boot_putx(ctx_ptpr);
+boot_puts("\n  - ctx[TTY]    = ");
+boot_putd(ctx_tty);
+boot_puts("\n  - ctx[NIC]    = ");
+boot_putd(ctx_nic);
+boot_puts("\n  - ctx[CMA]    = ");
+boot_putd(ctx_cma);
+boot_puts("\n  - ctx[IOC]    = ");
+boot_putd(ctx_ioc);
+boot_puts("\n  - ctx[TIM]    = ");
+boot_putd(ctx_tim);
+boot_puts("\n  - ctx[DMA]    = ");
+boot_putd(ctx_dma);
+boot_puts("\n  - ctx[PTAB]   = ");
+boot_putx(ctx_ptab);
+boot_puts("\n  - ctx[GTID]   = ");
+boot_putd(task_id);
+boot_puts("\n  - ctx[VSID]   = ");
+boot_putd(vspace_id);
+boot_puts("\n");
 #endif
 
@@ -1765,5 +1844,6 @@
 // This function is executed by P[0] to wakeup all processors.
 //////////////////////////////////////////////////////////////////////////////////
-void boot_start_all_procs() {
+void boot_start_all_procs() 
+{
     mapping_header_t * header = (mapping_header_t *) &seg_mapping_base;
     header->signature = OUT_MAPPING_SIGNATURE;
@@ -1786,6 +1866,5 @@
     boot_psegs_init();
 
-    boot_puts
-        ("\n[BOOT] Pseg allocators initialisation completed at cycle ");
+    boot_puts("\n[BOOT] Pseg allocators initialisation completed at cycle ");
     boot_putd(boot_proctime());
     boot_puts("\n");
@@ -1798,4 +1877,12 @@
     boot_puts("\n");
 
+    // mmu activation ( with page table [Ã] )
+    boot_set_mmu_ptpr( (unsigned int)(boot_ptabs_paddr[0] >> 13) );
+    boot_set_mmu_mode(0xF);
+
+    boot_puts("\n[BOOT] Proc 0 MMU activation at cycle ");
+    boot_putd(boot_proctime());
+    boot_puts("\n");
+
     // vobjs initialisation
     boot_vobjs_init();
@@ -1809,12 +1896,4 @@
 
     boot_puts("\n[BOOT] Peripherals initialisation completed at cycle ");
-    boot_putd(boot_proctime());
-    boot_puts("\n");
-
-    // mmu activation
-    boot_set_mmu_ptpr((unsigned int) boot_ptabs_paddr[0] >> 13);
-    boot_set_mmu_mode(0xF);
-
-    boot_puts("\n[BOOT] MMU activation completed at cycle ");
     boot_putd(boot_proctime());
     boot_puts("\n");
